# Class OsgiPluginConvention

java.lang.Object
org.gradle.api.plugins.osgi.OsgiPluginConvention

public class OsgiPluginConvention extends Object
Is mixed into the project when applying the `OsgiPlugin`.

## Constructor Summary

Constructors
Constructor
Description
`OsgiPluginConvention(org.gradle.api.internal.project.ProjectInternal project)`

## Method Summary

Modifier and Type
Method
Description
`OsgiManifest`
`osgiManifest()`
Creates a new instance of `OsgiManifest`.
`OsgiManifest`
`osgiManifest(Closure closure)`
Creates and configures a new instance of an `OsgiManifest` .
`OsgiManifest`
`osgiManifest(Action<? super OsgiManifest> action)`
Creates and configures a new instance of an `OsgiManifest`.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### OsgiPluginConvention

public OsgiPluginConvention(org.gradle.api.internal.project.ProjectInternal project)

## Method Details

### osgiManifest

public OsgiManifest osgiManifest()
Creates a new instance of `OsgiManifest`. The returned object is preconfigured with:

    version: project.version
    name: project.archivesBaseName
    symbolicName: project.group + "." + project.archivesBaseName (see below for exceptions to this rule)

The symbolic name is usually the group + "." + archivesBaseName, with the following exceptions

- if group has only one section (no dots) and archivesBaseName is not null then the first package name with classes is returned. eg. commons-logging:commons-logging -> org.apache.commons.logging
- if archivesBaseName is equal to last section of group then group is returned. eg. org.gradle:gradle -> org.gradle
- if archivesBaseName starts with last section of group that portion is removed. eg. org.gradle:gradle-core -> org.gradle.core

### osgiManifest

public OsgiManifest osgiManifest(Closure closure)
Creates and configures a new instance of an `OsgiManifest` . The closure configures the new manifest instance before it is returned.

### osgiManifest

public OsgiManifest osgiManifest(Action<? super OsgiManifest> action)
Creates and configures a new instance of an `OsgiManifest`. The action configures the new manifest instance before it is returned.

Since:
  3.5